#include "Function.h"
#include <Log.h>

namespace JadeGit::Development
{
	// Allows whitelisted functions (no special handling required)
	class WhitelistFunction : public Function
	{
	public:
		WhitelistFunction() : Function
		({
			AccessClasses,
			AccessToAdminFns,			// Administration
			AccessToClassFns,
			AccessToConstantFns,
			AccessToHistoryFns,
			AccessToInterfaceFns,
			AccessToMethodFns,
			AccessToPropertyFns,
			AddApplication,
			AddClass,
			AddCondition,
			AddConstant,
			AddConsumer,
			AddCurrencyFormat,
			AddExposureList,
			AddExternalMethod,
			AddExtFunction,
			AddForm,
			AddGblConstsCategory,
			AddGlobalConstant,
			AddInterface,
			AddJadeMethod,
			AddLibrary,
			AddLongDateFormat,
			AddMapFile,
			AddMethodView,
			AddNumericFormat,
			AddPackage,
			AddProperty,
			AddRelationalView,
			AddSchemaView,
			AddShortDateFormat,
			AddSubclass,
			AddTimeFormat,
			BroadcastMessage,
			BrowseActiveXLibrary,
			BrowseApplications,
			BrowseBreakpoints,
			BrowseChangedMethods,
			BrowseChkOutMethods,
			BrowseClassesInUse,
			BrowseConstants,
			BrowseConsumer,
			BrowseExportPackages,
			BrowseExposedLists,
			BrowseExposureList,
			BrowseExtFunctions,
			BrowseFormats,
			BrowseHTML,
			BrowseImportPackages,
			BrowseInterfaces,
			BrowseLibraries,
			BrowseLocales,
			BrowseMapFiles,
			BrowseMethods,
			BrowseMethodStatusList,
			BrowseMthdStatusList,
			BrowsePackageClasses,
			BrowsePackageUsages,
			BrowsePrimTypes,
			BrowseRelViews,
			BrowseSchemaViews,
			BrowseTranslateForms,
			BrowseTranslateStrings,
			BrowseUnreferMethods,
			ChangeClassCluster,
			ChangeFunction,
			ChangeMethod,
			ChangeMethodView,
			ChangeSchemaView,			// Schema views are currently ignored (incomplete/inconsistent patch control & schema load behaviour)
			CloseSchemaWindows,
			CompareMethods,
	//		CompileClass,				// duplicate of CompileMethod
	//		CompileExtFunction,			// duplicate of CompileMethod
			CompileMethod,
			CompileType,
			Component_ActiveX,
			Component_DotNet,
			ClearHistory,
			CopyMethod,
			CopyMethodView,
			CreateMappingMethod,
			DebugJadeScript,
			DisplayVersionInfo,
			EditCopy,
			EditCut,
			EditPaste,
			EditRedo,
			EditUndo,
			EnableInspectToolbar,
			ExecuteJadeScript,
			ExpandSchemaHierarchy,
			ExtractActiveX,
			ExtractAll,
	//		ExtractAllMethods,			// duplicate of ExtractAll
			ExtractConsumer,
			ExtractDotNetLib,
			ExtractExposureList,
			ExtractExternalDb,
			ExtractFunction,
			ExtractHTMLDocument,
			ExtractInterface,
			ExtractMethod,
			ExtractMethod1,
			ExtractMethods,
			ExtractMethodView,
			ExtractPackage,
	//		ExtractPrimType,			// duplicate of ExtractType
			ExtractRelationalView,
			ExtractRemapTable,
			ExtractRPSView,
			ExtractSchema,
			ExtractSchemaView,
			ExtractType,
			FindBookmark,
			FindClass,
			FindCodePosition,
			FindCollClsRefs,
			FindConstantRefs,
	//		FindExtFunctionRefs,		// duplicate of FindMethodRefs
			FindFormatRefs,
			FindGblConstant,
			FindGblConstsRefs,
			FindInterface,
			FindMethodImpls,
			FindMethodLocalImpls,
			FindMethodLocalImplsRefs,
			FindMethodLocalRefs,
	//		FindMethodReferences,		// duplicate of FindMethodRefs
			FindMethodRefs,
	//		FindPrimType,				// duplicate of FindClass
	//		FindPrimTypeRefs,			// duplicate of FindTypeRefs
			FindPropertyReadRefs,
			FindPropertyRefs,
			FindPropertyUpdateRefs,
			FindSchema,
			FindTransientLeaks,
			FindTypeRefs,
			FindUnusedClassEntities,
			FindUnusedLocalVars,
			GenerateJavaScript,
			GenerateTestCase,
			InspectAllPersntInsts,
			InspectMethod,
			InspectPersistentInsts,
			InspectSchemaTransients,
			InspectTransientInsts,
			InspectorSearch,
			InterfaceMapper,
			LoadRelationalView,
			LoadSchema,
			Messages,
			MethodsViewMenu,
			MoveClass,
			MoveMethod,
			NewWorkspace,
			OpenSchemaView,
			OpenWorkspace,
			PackageAddClass,
			PackageAddConstant,
			PackageAddInterface,
			PackageAddMethod,
			PackageAddProperty,
			PackageChangeProperty,
			PackageChangeType,
			PackageFindType,
			PackageRemoveConstant,
			PackageRemoveMethod,
			PackageRemoveProperty,
			PackageRemoveType,
			PrintExternalDb,
			PrintMethod,
			PrintRelationalView,
			PrintRPSView,
			PrintSchema,
			PrintSelected,
			PrintSetup,
			RegisterActiveXServer,
			RemoveBreakpoint,
			RemoveConstant,
			RemoveExposureList,
			RemoveExtFunction,
			RemoveFormat,
			RemoveGblConstant,
			RemoveGblConstsCategory,
			RemoveInterface,
			RemoveLibrary,
			RemoveMapFile,
			RemoveMethod,
			RemoveMethodFromList,
			RemoveMethodView,
			RemovePackage,
			RemoveProperty,
			RemoveRelationalView,
			RemoveSchemaView,
			RemoveUnusedLocalVariables,
			ResetUserPreferences,		// Administration
			RunApplication,
			Save,
			SaveHTML,
			SaveMethod,
			SaveMethodAs,
			SchemaEntityBrowse,			// Methods viewer
			SchemaEntityRecent,
			SchemaEntityView,
			SchemaEntityViewNew,
			SearchInstances,
			SearchListedMethods,
			SetApplication,
			SetBookmark,
			SetBreakpoint,
			SetConstantsSortOrder,
			SetConstantText,
			SetExtFunctionText,
	//		SetGblConstsSortOrder,		// duplicate of SetConstantsSortOrder
			SetGlobalConstantText,
			SetHTMLText,
			SetMethodText,
			SetPropertyText,
	//		SetSchemaText,				// Further investigation required, patch control hook not called for update
			SetSchemaView,
			SetSchemaViewText,
			SetTypesSortOrder,
			SetTypeText,
			SetText,
			SetUserPreferences,			// Administration
			ShowAllMethodView,
			ShowBackupDb,				// Administration
			ShowCompositeVersion,
			ShowCurrentVersion,
			ShowEditForm,
			ShowEditForm2,
			ShowFormWizard,
			ShowGlobalFindReplace,
			ShowInterfaceMappings,
			ShowLatestVersion,
			ShowLocalFindReplace,
			ShowMonitor,
			ShowPromoteConstant,
			ShowProtected,
			ShowPublic,
			ShowQuickNavigation,
			ShowReadOnly,
			ShowRelationDiagram,
			ShowRelatnDiagramOptions,
			ShowUserPreferences,
			ShowWSDLMappings,
			ShowXMIImport,
			UnregisterActiveXServer,
			UserPreferences_Logoff,		// Administration
			ValidateSchema,
			ViewBubbleHelp,
			ViewClass,
			ViewCompiledMethods,
			ViewExpandedHTree,
			ViewInherited,
			ViewLibrarySuperscms,
			ViewMethodSource,
			ViewMethodsInError,
			ViewMethodsPane,
	//		ViewPrimType,				// duplicate of ViewClass
			ViewPropertiesPane,
			ViewResetRoot,
			ViewSetRoot,
			ViewSuperschemas,
			ViewUncompiledMethods,
			WebServicesOptions,
			ZoomInRelationDiagram,
			ZoomOutRelationDiagram
		}) {};

	protected:
		bool execute(const std::string& entityName) const override
		{
			LOG_TRACE("whitelisted");
			return true;
		}
	};
	static WhitelistFunction whitelist;
}